
from typing import Any, Tuple, Optional



class MTMainRouter:

    _appContext = None


    def __init__(self, appContext):
        self._appContext = appContext

    def _on_pycmd_message(
        self, handled: Tuple[bool, Any], message: str, context: Any
    ) -> Tuple[bool, Optional[Any]]:
        
        if handled[0]: # if true
            ##print("handled already")
            # Return True if another handler has already processed the command
            return handled

        if message.startswith('meditricks'):
            
            #print("Command received:", message)
            args = message.split(":", 3)
            if (args[1] == "toolbar"):
                #print("clicked toolbar button")
                
                self._appContext.clickedToolbar()
                
                return True, None  # Return True to indicate that the message has been handled
            
            elif (args[1] == "profile"):
                if (args[2] == "destroyLogin"):
                    #print("destroylogin")
                    
                    self._appContext.destroyLogin()
                    
                    return True, None  # Return True to indicate that the message has been handled
                elif (args[2] == "upvoteCounter"):
                    #print("upvoting")
                    
                    self._appContext.upvote_MTCounter()
                    
                    return True, None  # Return True to indicate that the message has been handled

        # Return False to indicate that the message has not been handled
        return False, None