from aqt import mw

from typing import Any
from aqt import QObject, pyqtSlot

from .config import MTCONFIG

class MTWindowBackend(QObject):

    def __init__(self, callingWindow):
        super().__init__()
        self.callingWindow = callingWindow

    @pyqtSlot(str, result=str)  # type: ignore
    def cmd(self, str: str) -> Any:
        #return json.dumps(self.onCmd(str))
        #print("called cmd")
        #print(str)
        return ""

    @pyqtSlot(str, str)
    def login(self, username, password):
        #print(f"Attempting login with Username: {username}")
        #print(f"Attempting login with password: {password}")
        mw.MTAppContext.doLogin(username, password)


    @pyqtSlot()
    def login_ui_finished(self):
        mw.MTAppContext.login_ui_finished()

        
    @pyqtSlot(str, bool)
    def settings_toggle(self, name, state):
        #print("saving settings:", name)
        #print("saving settings:", state)
        if name == "autounfold":
            mw.MTAppContext.writeSettings("cards_mtbutton_autounfold",state)
        if name == "autoankiboxpin":
            mw.MTAppContext.writeSettings("cards_mtbutton_autoankiboxpin",state)
        elif name == "cardsemulateiframe":
            mw.MTAppContext.writeSettings("cards_dev_emulate_iframe",state)
        elif name == "cardsemulateiframegdpr":
            mw.MTAppContext.writeSettings("cards_dev_emulate_iframe_gdpr",state)


    @pyqtSlot()
    def startTrial(self):
        #print(f"starting trial")
        
        mw.MTAppContext.doStartTrial()

    @pyqtSlot()
    def relogin(self):
        #print(f"doing relogin")
        
        mw.MTAppContext.doReLogin()

    
    @pyqtSlot()
    def logout(self):
        #print("logout")

        mw.MTAppContext.doLogout()
        self.callingWindow.load_login_page()
    
                
    