
from typing import Any, List, Union

from aqt.toolbar import TopToolbar  
from aqt.webview import WebContent  

from .config import MTCONFIG

config = MTCONFIG

class ToolbarIcon():
        
           

    def getHTML(self):
        
        iconPath = config['WEBVIEW_PATH']+"/gfx/logo200px.png"
        html = """ <script type="text/javascript" src="qrc:///qtwebchannel/qwebchannel.js"></script>
        <a class="meditricks-mt-toolbar-a"
            title="Meditricks"
            href=#
            onclick="return pycmd('meditricks:toolbar:toggle');"
            ><img src="{iconPath}" class="meditricks-mt-toolbar-icon" />
            <span
            class="meditricks-mt-toolbar-text "
            > Meditricks
            </span>
            </a>
            """
        html = html.format(iconPath=iconPath)
        return html
    


class MTToolbarHandler():
     
    def on_top_toolbar_will_set_tray_content(self, el: List[str], *args):
        
        toolbaricon = ToolbarIcon()
        html = toolbaricon.getHTML()
        
        el.append(html)

    
    def on_webview_will_set_content(
            self, web_content: "WebContent", context: Union[Any, "TopToolbar"]
        ):
            if TopToolbar is None or not isinstance(context, TopToolbar):
                return

            web_content.css.append(config['WEBVIEW_PATH']+"/css/toolbar.css")